DefaultFocusTraversalPolicy (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt, class: DefaultFocusTraversalPolicy
Keywords: java.awt.DefaultFocusTraversalPolicy class

# Class DefaultFocusTraversalPolicy

java.lang.Object
java.awt.FocusTraversalPolicy
java.awt.ContainerOrderFocusTraversalPolicy
java.awt.DefaultFocusTraversalPolicy

All Implemented Interfaces:
  `Serializable`

public class DefaultFocusTraversalPolicy extends ContainerOrderFocusTraversalPolicy
A FocusTraversalPolicy that determines traversal order based on the order of child Components in a Container. From a particular focus cycle root, the policy makes a pre-order traversal of the Component hierarchy, and traverses a Container's children according to the ordering of the array returned by `Container.getComponents()`. Portions of the hierarchy that are not visible and displayable will not be searched.

If client code has explicitly set the focusability of a Component by either overriding `Component.isFocusTraversable()` or `Component.isFocusable()`, or by calling `Component.setFocusable()`, then a DefaultFocusTraversalPolicy behaves exactly like a ContainerOrderFocusTraversalPolicy. If, however, the Component is relying on default focusability, then a DefaultFocusTraversalPolicy will reject all Components with non-focusable peers. This is the default FocusTraversalPolicy for all AWT Containers.

The focusability of a peer is implementation-dependent. Sun recommends that all implementations for a particular native platform construct peers with the same focusability. The recommendations for Windows and Unix are that Canvases, Labels, Panels, Scrollbars, ScrollPanes, Windows, and lightweight Components have non-focusable peers, and all other Components have focusable peers. These recommendations are used in the Sun AWT implementations. Note that the focusability of a Component's peer is different from, and does not impact, the focusability of the Component itself.

Please see How to Use the Focus Subsystem, a section in The Java Tutorial, and the Focus Specification for more information.

Since:
  1.4
See Also:
  - `Container.getComponents()`
  - `Component.isFocusable()`
  - `Component.setFocusable(boolean)`
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultFocusTraversalPolicy()`
  Constructs a `DefaultFocusTraversalPolicy`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `accept(Component aComponent)`
  Determines whether a Component is an acceptable choice as the new focus owner.

  ### Methods declared in class ContainerOrderFocusTraversalPolicy

  `getComponentAfter, getComponentBefore, getDefaultComponent, getFirstComponent, getImplicitDownCycleTraversal, getLastComponent, setImplicitDownCycleTraversal`
  Modifier and Type
  Method
  Description
  `Component`
  `getComponentAfter(Container aContainer, Component aComponent)`
  Returns the Component that should receive the focus after aComponent. aContainer must be a focus cycle root of aComponent or a focus traversal policy provider.
  `Component`
  `getComponentBefore(Container aContainer, Component aComponent)`
  Returns the Component that should receive the focus before aComponent. aContainer must be a focus cycle root of aComponent or a focus traversal policy provider.
  `Component`
  `getDefaultComponent(Container aContainer)`
  Returns the default Component to focus.
  `Component`
  `getFirstComponent(Container aContainer)`
  Returns the first Component in the traversal cycle.
  `boolean`
  `getImplicitDownCycleTraversal()`
  Returns whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly.
  `Component`
  `getLastComponent(Container aContainer)`
  Returns the last Component in the traversal cycle.
  `void`
  `setImplicitDownCycleTraversal(boolean implicitDownCycleTraversal)`
  Sets whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly.

  ### Methods declared in class FocusTraversalPolicy

  `getInitialComponent`
  Modifier and Type
  Method
  Description
  `Component`
  `getInitialComponent(Window window)`
  Returns the Component that should receive the focus when a Window is made visible for the first time.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### DefaultFocusTraversalPolicy

    public DefaultFocusTraversalPolicy()
    Constructs a `DefaultFocusTraversalPolicy`.

- ## Method Details

  - ### accept

    protected boolean accept(Component aComponent)
    Determines whether a Component is an acceptable choice as the new focus owner. The Component must be visible, displayable, and enabled to be accepted. If client code has explicitly set the focusability of the Component by either overriding `Component.isFocusTraversable()` or `Component.isFocusable()`, or by calling `Component.setFocusable()`, then the Component will be accepted if and only if it is focusable. If, however, the Component is relying on default focusability, then all Canvases, Labels, Panels, Scrollbars, ScrollPanes, Windows, and lightweight Components will be rejected.
    Overrides:
      `accept` in class `ContainerOrderFocusTraversalPolicy`
    Parameters:
      `aComponent` - the Component whose fitness as a focus owner is to be tested
    Returns:
      `true` if aComponent meets the above requirements; `false` otherwise